Index: branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1376)
+++ branches/SHM-dev/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 1377)
@@ -2161,10 +2197,10 @@
     if(strcmp(cfg_scaledRefLayerOffsetPresentFlag[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_scaledRefLayerOffsetPresentFlag[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "ScaledRefLayerOffsetPresentFlag");
+      cfgStringToArray( &tempArray, cfg_scaledRefLayerOffsetPresentFlag[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "ScaledRefLayerOffsetPresentFlag");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_scaledRefLayerOffsetPresentFlag[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_scaledRefLayerOffsetPresentFlag[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2175,10 +2211,10 @@
     if(strcmp(cfg_scaledRefLayerLeftOffset[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_scaledRefLayerLeftOffset[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "LeftOffset");
+      cfgStringToArray( &tempArray, cfg_scaledRefLayerLeftOffset[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "LeftOffset");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_scaledRefLayerLeftOffset[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_scaledRefLayerLeftOffset[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2189,10 +2225,10 @@
     if(strcmp(cfg_scaledRefLayerTopOffset[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_scaledRefLayerTopOffset[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "TopOffset");
+      cfgStringToArray( &tempArray, cfg_scaledRefLayerTopOffset[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "TopOffset");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_scaledRefLayerTopOffset[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_scaledRefLayerTopOffset[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2203,10 +2239,10 @@
     if(strcmp(cfg_scaledRefLayerRightOffset[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_scaledRefLayerRightOffset[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "RightOffset");
+      cfgStringToArray( &tempArray, cfg_scaledRefLayerRightOffset[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "RightOffset");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_scaledRefLayerRightOffset[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_scaledRefLayerRightOffset[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2217,10 +2253,10 @@
     if(strcmp(cfg_scaledRefLayerBottomOffset[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_scaledRefLayerBottomOffset[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "BottomOffset");
+      cfgStringToArray( &tempArray, cfg_scaledRefLayerBottomOffset[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "BottomOffset");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_scaledRefLayerBottomOffset[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_scaledRefLayerBottomOffset[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2231,10 +2267,10 @@
     if(strcmp(cfg_refRegionOffsetPresentFlag[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_refRegionOffsetPresentFlag[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "RefRegionOffsetPresentFlag");
+      cfgStringToArray( &tempArray, cfg_refRegionOffsetPresentFlag[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "RefRegionOffsetPresentFlag");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_refRegionOffsetPresentFlag[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_refRegionOffsetPresentFlag[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2245,10 +2281,10 @@
     if(strcmp(cfg_refRegionLeftOffset[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_refRegionLeftOffset[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "RefRegionLeftOffset");
+      cfgStringToArray( &tempArray, cfg_refRegionLeftOffset[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "RefRegionLeftOffset");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_refRegionLeftOffset[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_refRegionLeftOffset[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2259,10 +2295,10 @@
     if(strcmp(cfg_refRegionTopOffset[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_refRegionTopOffset[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "RefRegionTopOffset");
+      cfgStringToArray( &tempArray, cfg_refRegionTopOffset[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "RefRegionTopOffset");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_refRegionTopOffset[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_refRegionTopOffset[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2273,10 +2309,10 @@
     if(strcmp(cfg_refRegionRightOffset[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_refRegionRightOffset[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "RefRegionRightOffset");
+      cfgStringToArray( &tempArray, cfg_refRegionRightOffset[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "RefRegionRightOffset");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_refRegionRightOffset[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_refRegionRightOffset[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2287,10 +2323,10 @@
     if(strcmp(cfg_refRegionBottomOffset[layer].c_str(),  ""))
     {
-      cfgStringToArray( &tempArray, cfg_refRegionBottomOffset[layer], m_acLayerCfg[layer].m_numRefLayerLocationOffsets, "RefRegionBottomOffset");
+      cfgStringToArray( &tempArray, cfg_refRegionBottomOffset[layer], m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets, "RefRegionBottomOffset");
       if(tempArray)
       {
-        for(Int i = 0; i < m_acLayerCfg[layer].m_numRefLayerLocationOffsets; i++)
+        for(Int i = 0; i < m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets; i++)
         {
-          m_acLayerCfg[layer].m_refRegionBottomOffset[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_refRegionBottomOffset[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2298,5 +2334,5 @@
     }
 
-    Int numPhaseSet = m_acLayerCfg[layer].m_numRefLayerLocationOffsets;
+    Int numPhaseSet = m_apcLayerCfg[layer]->m_numRefLayerLocationOffsets;
 
     // Presense Flag //
@@ -2308,5 +2344,5 @@
         for(Int i = 0; i < numPhaseSet; i++)
         {
-          m_acLayerCfg[layer].m_resamplePhaseSetPresentFlag[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_resamplePhaseSetPresentFlag[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2322,5 +2358,5 @@
         for(Int i = 0; i < numPhaseSet; i++)
         {
-          m_acLayerCfg[layer].m_phaseHorLuma[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_phaseHorLuma[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2336,5 +2372,5 @@
         for(Int i = 0; i < numPhaseSet; i++)
         {
-          m_acLayerCfg[layer].m_phaseVerLuma[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_phaseVerLuma[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2350,5 +2386,5 @@
         for(Int i = 0; i < numPhaseSet; i++)
         {
-          m_acLayerCfg[layer].m_phaseHorChroma[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_phaseHorChroma[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2364,5 +2400,5 @@
         for(Int i = 0; i < numPhaseSet; i++)
         {
-          m_acLayerCfg[layer].m_phaseVerChroma[i] = tempArray[i];
+          m_apcLayerCfg[layer]->m_phaseVerChroma[i] = tempArray[i];
         }
         delete [] tempArray; tempArray = NULL;
@@ -2371,22 +2407,22 @@
 
     Char* pSamplePredRefLayerIds = cfg_samplePredRefLayerIds[layer].empty() ? NULL: strdup(cfg_samplePredRefLayerIds[layer].c_str());
-    if( m_acLayerCfg[layer].m_numSamplePredRefLayers > 0 )
+    if( m_apcLayerCfg[layer]->m_numSamplePredRefLayers > 0 )
     {
       char *samplePredRefLayerId;
       int  i=0;
-      m_acLayerCfg[layer].m_samplePredRefLayerIds = new Int[m_acLayerCfg[layer].m_numSamplePredRefLayers];
+      m_apcLayerCfg[layer]->m_samplePredRefLayerIds = new Int[m_apcLayerCfg[layer]->m_numSamplePredRefLayers];
       samplePredRefLayerId = strtok(pSamplePredRefLayerIds, " ,-");
       while(samplePredRefLayerId != NULL)
       {
-        if( i >= m_acLayerCfg[layer].m_numSamplePredRefLayers )
+        if( i >= m_apcLayerCfg[layer]->m_numSamplePredRefLayers )
         {
           printf( "NumSamplePredRefLayers%d: The number of columns whose width are defined is larger than the allowed number of columns.\n", layer );
           exit( EXIT_FAILURE );
         }
-        *( m_acLayerCfg[layer].m_samplePredRefLayerIds + i ) = atoi( samplePredRefLayerId );
+        *( m_apcLayerCfg[layer]->m_samplePredRefLayerIds + i ) = atoi( samplePredRefLayerId );
         samplePredRefLayerId = strtok(NULL, " ,-");
         i++;
       }
-      if( i < m_acLayerCfg[layer].m_numSamplePredRefLayers )
+      if( i < m_apcLayerCfg[layer]->m_numSamplePredRefLayers )
       {
         printf( "NumSamplePredRefLayers%d: The width of some columns is not defined.\n", layer );
@@ -2396,5 +2432,5 @@
     else
     {
-      m_acLayerCfg[layer].m_samplePredRefLayerIds = NULL;
+      m_apcLayerCfg[layer]->m_samplePredRefLayerIds = NULL;
     }
 
@@ -2406,22 +2442,22 @@
 
     Char* pMotionPredRefLayerIds = cfg_motionPredRefLayerIds[layer].empty() ? NULL: strdup(cfg_motionPredRefLayerIds[layer].c_str());
-    if( m_acLayerCfg[layer].m_numMotionPredRefLayers > 0 )
+    if( m_apcLayerCfg[layer]->m_numMotionPredRefLayers > 0 )
     {
       char *motionPredRefLayerId;
       int  i=0;
-      m_acLayerCfg[layer].m_motionPredRefLayerIds = new Int[m_acLayerCfg[layer].m_numMotionPredRefLayers];
+      m_apcLayerCfg[layer]->m_motionPredRefLayerIds = new Int[m_apcLayerCfg[layer]->m_numMotionPredRefLayers];
       motionPredRefLayerId = strtok(pMotionPredRefLayerIds, " ,-");
       while(motionPredRefLayerId != NULL)
       {
-        if( i >= m_acLayerCfg[layer].m_numMotionPredRefLayers )
+        if( i >= m_apcLayerCfg[layer]->m_numMotionPredRefLayers )
         {
           printf( "NumMotionPredRefLayers%d: The number of columns whose width are defined is larger than the allowed number of columns.\n", layer );
           exit( EXIT_FAILURE );
         }
-        *( m_acLayerCfg[layer].m_motionPredRefLayerIds + i ) = atoi( motionPredRefLayerId );
+        *( m_apcLayerCfg[layer]->m_motionPredRefLayerIds + i ) = atoi( motionPredRefLayerId );
         motionPredRefLayerId = strtok(NULL, " ,-");
         i++;
       }
-      if( i < m_acLayerCfg[layer].m_numMotionPredRefLayers )
+      if( i < m_apcLayerCfg[layer]->m_numMotionPredRefLayers )
       {
         printf( "NumMotionPredRefLayers%d: The width of some columns is not defined.\n", layer );
@@ -2431,5 +2467,5 @@
     else
     {
-      m_acLayerCfg[layer].m_motionPredRefLayerIds = NULL;
+      m_apcLayerCfg[layer]->m_motionPredRefLayerIds = NULL;
     }
 
@@ -2441,22 +2477,22 @@
 
     Char* pPredLayerIds = cfg_predLayerIds[layer].empty() ? NULL: strdup(cfg_predLayerIds[layer].c_str());
-    if( m_acLayerCfg[layer].m_numActiveRefLayers > 0 )
+    if( m_apcLayerCfg[layer]->m_numActiveRefLayers > 0 )
     {
       char *refLayerId;
       int  i=0;
-      m_acLayerCfg[layer].m_predLayerIds = new Int[m_acLayerCfg[layer].m_numActiveRefLayers];
+      m_apcLayerCfg[layer]->m_predLayerIds = new Int[m_apcLayerCfg[layer]->m_numActiveRefLayers];
       refLayerId = strtok(pPredLayerIds, " ,-");
       while(refLayerId != NULL)
       {
-        if( i >= m_acLayerCfg[layer].m_numActiveRefLayers )
+        if( i >= m_apcLayerCfg[layer]->m_numActiveRefLayers )
         {
           printf( "NumActiveRefLayers%d: The number of columns whose width are defined is larger than the allowed number of columns.\n", layer );
           exit( EXIT_FAILURE );
         }
-        *( m_acLayerCfg[layer].m_predLayerIds + i ) = atoi( refLayerId );
+        *( m_apcLayerCfg[layer]->m_predLayerIds + i ) = atoi( refLayerId );
         refLayerId = strtok(NULL, " ,-");
         i++;
       }
-      if( i < m_acLayerCfg[layer].m_numActiveRefLayers )
+      if( i < m_apcLayerCfg[layer]->m_numActiveRefLayers )
       {
         printf( "NumActiveRefLayers%d: The width of some columns is not defined.\n", layer );
@@ -2466,5 +2502,5 @@
     else
     {
-      m_acLayerCfg[layer].m_predLayerIds = NULL;
+      m_apcLayerCfg[layer]->m_predLayerIds = NULL;
     }
 
@@ -2474,5 +2510,5 @@
       pPredLayerIds = NULL;
     }
-  } //for(Int layer = 0; layer < MAX_LAYERS; layer++)
+  } //for(Int layer = 0; layer < m_numLayers; layer++)
 
   for (Int layerSet = 1; layerSet < m_numLayerSets; layerSet++)
@@ -2919,11 +2955,11 @@
   {
     UInt uiAddCUDepth  = 0;
-    while( (m_acLayerCfg[layerIdx].m_uiMaxCUWidth>>m_acLayerCfg[layerIdx].m_uiMaxCUDepth) > ( 1 << ( m_acLayerCfg[layerIdx].m_uiQuadtreeTULog2MinSize + uiAddCUDepth )  ) )
+    while( (m_apcLayerCfg[layerIdx]->m_uiMaxCUWidth>>m_apcLayerCfg[layerIdx]->m_uiMaxCUDepth) > ( 1 << ( m_apcLayerCfg[layerIdx]->m_uiQuadtreeTULog2MinSize + uiAddCUDepth )  ) )
     {
       uiAddCUDepth++;
     }
 
-    m_acLayerCfg[layerIdx].m_uiMaxTotalCUDepth = m_acLayerCfg[layerIdx].m_uiMaxCUDepth + uiAddCUDepth + getMaxCUDepthOffset(m_acLayerCfg[layerIdx].m_chromaFormatIDC, m_acLayerCfg[layerIdx].m_uiQuadtreeTULog2MinSize); // if minimum TU larger than 4x4, allow for additional part indices for 4:2:2 SubTUs.    
-    m_acLayerCfg[layerIdx].m_uiLog2DiffMaxMinCodingBlockSize = m_acLayerCfg[layerIdx].m_uiMaxCUDepth - 1;
+    m_apcLayerCfg[layerIdx]->m_uiMaxTotalCUDepth = m_apcLayerCfg[layerIdx]->m_uiMaxCUDepth + uiAddCUDepth + getMaxCUDepthOffset(m_apcLayerCfg[layerIdx]->m_chromaFormatIDC, m_apcLayerCfg[layerIdx]->m_uiQuadtreeTULog2MinSize); // if minimum TU larger than 4x4, allow for additional part indices for 4:2:2 SubTUs.    
+    m_apcLayerCfg[layerIdx]->m_uiLog2DiffMaxMinCodingBlockSize = m_apcLayerCfg[layerIdx]->m_uiMaxCUDepth - 1;
   }
 #else  
@@ -2952,23 +2988,23 @@
 Void TAppEncCfg::xCheckParameter(UInt layerIdx)
 {
-  Bool m_extendedPrecisionProcessingFlag     = m_acLayerCfg[layerIdx].m_extendedPrecisionProcessingFlag;
-  Bool m_highPrecisionOffsetsEnabledFlag     = m_acLayerCfg[layerIdx].m_highPrecisionOffsetsEnabledFlag;
-  ChromaFormat m_chromaFormatIDC             = m_acLayerCfg[layerIdx].m_chromaFormatIDC;
-  ChromaFormat m_chromaFormatConstraint      = m_acLayerCfg[layerIdx].m_chromaFormatConstraint;
-  ChromaFormat m_InputChromaFormatIDC        = m_acLayerCfg[layerIdx].m_InputChromaFormatIDC;
-
-  Int m_inputBitDepth[]       = {m_acLayerCfg[layerIdx].m_inputBitDepth[CHANNEL_TYPE_LUMA],       m_acLayerCfg[layerIdx].m_inputBitDepth[CHANNEL_TYPE_CHROMA]};
-  Int m_internalBitDepth[]    = {m_acLayerCfg[layerIdx].m_internalBitDepth[CHANNEL_TYPE_LUMA],    m_acLayerCfg[layerIdx].m_internalBitDepth[CHANNEL_TYPE_CHROMA]};
-  Int m_MSBExtendedBitDepth[] = {m_acLayerCfg[layerIdx].m_MSBExtendedBitDepth[CHANNEL_TYPE_LUMA], m_acLayerCfg[layerIdx].m_MSBExtendedBitDepth[CHANNEL_TYPE_CHROMA]};  
-
-  m_log2SaoOffsetScale[CHANNEL_TYPE_LUMA]   = m_acLayerCfg[layerIdx].m_log2SaoOffsetScale[CHANNEL_TYPE_LUMA];
-  m_log2SaoOffsetScale[CHANNEL_TYPE_CHROMA] = m_acLayerCfg[layerIdx].m_log2SaoOffsetScale[CHANNEL_TYPE_CHROMA];
-
-  Int layerPTLIdx = m_acLayerCfg[layerIdx].m_layerPTLIdx;
+  Bool m_extendedPrecisionProcessingFlag     = m_apcLayerCfg[layerIdx]->m_extendedPrecisionProcessingFlag;
+  Bool m_highPrecisionOffsetsEnabledFlag     = m_apcLayerCfg[layerIdx]->m_highPrecisionOffsetsEnabledFlag;
+  ChromaFormat m_chromaFormatIDC             = m_apcLayerCfg[layerIdx]->m_chromaFormatIDC;
+  ChromaFormat m_chromaFormatConstraint      = m_apcLayerCfg[layerIdx]->m_chromaFormatConstraint;
+  ChromaFormat m_InputChromaFormatIDC        = m_apcLayerCfg[layerIdx]->m_InputChromaFormatIDC;
+
+  Int m_inputBitDepth[]       = {m_apcLayerCfg[layerIdx]->m_inputBitDepth[CHANNEL_TYPE_LUMA],       m_apcLayerCfg[layerIdx]->m_inputBitDepth[CHANNEL_TYPE_CHROMA]};
+  Int m_internalBitDepth[]    = {m_apcLayerCfg[layerIdx]->m_internalBitDepth[CHANNEL_TYPE_LUMA],    m_apcLayerCfg[layerIdx]->m_internalBitDepth[CHANNEL_TYPE_CHROMA]};
+  Int m_MSBExtendedBitDepth[] = {m_apcLayerCfg[layerIdx]->m_MSBExtendedBitDepth[CHANNEL_TYPE_LUMA], m_apcLayerCfg[layerIdx]->m_MSBExtendedBitDepth[CHANNEL_TYPE_CHROMA]};  
+
+  m_log2SaoOffsetScale[CHANNEL_TYPE_LUMA]   = m_apcLayerCfg[layerIdx]->m_log2SaoOffsetScale[CHANNEL_TYPE_LUMA];
+  m_log2SaoOffsetScale[CHANNEL_TYPE_CHROMA] = m_apcLayerCfg[layerIdx]->m_log2SaoOffsetScale[CHANNEL_TYPE_CHROMA];
+
+  Int layerPTLIdx = m_apcLayerCfg[layerIdx]->m_layerPTLIdx;
   Profile::Name m_profile             = m_profileList[layerPTLIdx];
-  UInt m_bitDepthConstraint           = m_acLayerCfg[layerIdx].m_bitDepthConstraint;
-  Bool m_intraConstraintFlag          = m_acLayerCfg[layerIdx].m_intraConstraintFlag;
-  Bool m_lowerBitRateConstraintFlag   = m_acLayerCfg[layerIdx].m_lowerBitRateConstraintFlag;
-  Bool m_onePictureOnlyConstraintFlag = m_acLayerCfg[layerIdx].m_onePictureOnlyConstraintFlag;
+  UInt m_bitDepthConstraint           = m_apcLayerCfg[layerIdx]->m_bitDepthConstraint;
+  Bool m_intraConstraintFlag          = m_apcLayerCfg[layerIdx]->m_intraConstraintFlag;
+  Bool m_lowerBitRateConstraintFlag   = m_apcLayerCfg[layerIdx]->m_lowerBitRateConstraintFlag;
+  Bool m_onePictureOnlyConstraintFlag = m_apcLayerCfg[layerIdx]->m_onePictureOnlyConstraintFlag;
 #else
 Void TAppEncCfg::xCheckParameter()
@@ -3323,5 +3359,5 @@
    * This permits the ability to omit a GOP structure specification */
 #if SVC_EXTENSION
-  if( m_acLayerCfg[0].m_iIntraPeriod == 1 && m_GOPList[0].m_POC == -1 )
+  if( m_apcLayerCfg[0]->m_iIntraPeriod == 1 && m_GOPList[0].m_POC == -1 )
   {
     m_GOPList[0] = GOPEntry();
@@ -3337,5 +3373,5 @@
   }
 
-  if (m_acLayerCfg[layerIdx].m_iIntraPeriod == 1 && m_EhGOPList[layerIdx][0].m_POC == -1) {
+  if (m_apcLayerCfg[layerIdx]->m_iIntraPeriod == 1 && m_EhGOPList[layerIdx][0].m_POC == -1) {
     m_EhGOPList[layerIdx][0] = GOPEntry();
     m_EhGOPList[layerIdx][0].m_QPFactor = 1;
@@ -3406,5 +3442,5 @@
 
   // verify layer configuration parameters
-  if(m_acLayerCfg[layerIdx].xCheckParameter(m_isField))
+  if(m_apcLayerCfg[layerIdx]->xCheckParameter(m_isField))
   {
     printf("\nError: invalid configuration parameter found in layer %d \n", layerIdx);
@@ -3413,5 +3449,5 @@
 
   // verify layer configuration parameters
-  Int m_iIntraPeriod = m_acLayerCfg[layerIdx].m_iIntraPeriod;
+  Int m_iIntraPeriod = m_apcLayerCfg[layerIdx]->m_iIntraPeriod;
 #endif
   if ( (m_iIntraPeriod != 1) && !m_loopFilterOffsetInPPS && (!m_bLoopFilterDisable) )
@@ -3726,5 +3762,5 @@
     for(UInt layer=0; layer<m_numLayers; layer++)
     {
-      if ( (m_acLayerCfg[layer].m_iIntraPeriod != 1) && !m_loopFilterOffsetInPPS && (!m_bLoopFilterDisable) )
+      if ( (m_apcLayerCfg[layer]->m_iIntraPeriod != 1) && !m_loopFilterOffsetInPPS && (!m_bLoopFilterDisable) )
       {
         for(Int i=0; i<m_iGOPSize; i++)
@@ -4018,11 +4054,11 @@
 
 #if SVC_EXTENSION // ToDo: it should be checked for the case when parameters are different for the layers
-  Int m_iSourceWidth = m_acLayerCfg[layerIdx].m_iSourceWidth;
-  Int m_iSourceHeight = m_acLayerCfg[layerIdx].m_iSourceHeight;
-  Int m_uiMaxCUWidth = m_acLayerCfg[layerIdx].m_uiMaxCUWidth;
-  Int m_uiMaxCUHeight = m_acLayerCfg[layerIdx].m_uiMaxCUHeight;
+  Int m_iSourceWidth = m_apcLayerCfg[layerIdx]->m_iSourceWidth;
+  Int m_iSourceHeight = m_apcLayerCfg[layerIdx]->m_iSourceHeight;
+  Int m_uiMaxCUWidth = m_apcLayerCfg[layerIdx]->m_uiMaxCUWidth;
+  Int m_uiMaxCUHeight = m_apcLayerCfg[layerIdx]->m_uiMaxCUHeight;
 
   Bool tileFlag = (m_numTileColumnsMinus1 > 0 || m_numTileRowsMinus1 > 0 );
-  Int m_iWaveFrontSynchro = m_acLayerCfg[layerIdx].m_waveFrontSynchro;
+  Int m_iWaveFrontSynchro = m_apcLayerCfg[layerIdx]->m_waveFrontSynchro;
   xConfirmPara( tileFlag && m_iWaveFrontSynchro,            "Tile and Wavefront can not be applied together");
 #endif
@@ -4157,12 +4193,12 @@
 
 #if RC_SHVC_HARMONIZATION
-  if ( m_acLayerCfg[layerIdx].m_RCEnableRateControl )
-  {
-    if ( m_acLayerCfg[layerIdx].m_RCForceIntraQP )
-    {
-      if ( m_acLayerCfg[layerIdx].m_RCInitialQP == 0 )
+  if ( m_apcLayerCfg[layerIdx]->m_RCEnableRateControl )
+  {
+    if ( m_apcLayerCfg[layerIdx]->m_RCForceIntraQP )
+    {
+      if ( m_apcLayerCfg[layerIdx]->m_RCInitialQP == 0 )
       {
         printf( "\nInitial QP for rate control is not specified. Reset not to use force intra QP!" );
-        m_acLayerCfg[layerIdx].m_RCForceIntraQP = false;
+        m_apcLayerCfg[layerIdx]->m_RCForceIntraQP = false;
       }
     }
@@ -4210,28 +4246,28 @@
 
 #if SVC_EXTENSION
-  xConfirmPara( (m_acLayerCfg[0].m_numSamplePredRefLayers != 0) && (m_acLayerCfg[0].m_numSamplePredRefLayers != -1), "Layer 0 cannot have any reference layers" );
+  xConfirmPara( (m_apcLayerCfg[0]->m_numSamplePredRefLayers != 0) && (m_apcLayerCfg[0]->m_numSamplePredRefLayers != -1), "Layer 0 cannot have any reference layers" );
   // NOTE: m_numSamplePredRefLayers  (for any layer) could be -1 (not signalled in cfg), in which case only the "previous layer" would be taken for reference
   if( layerIdx > 0 )
   {
-    xConfirmPara(m_acLayerCfg[layerIdx].m_numSamplePredRefLayers > layerIdx, "Cannot reference more layers than before current layer");
-    for(Int i = 0; i < m_acLayerCfg[layerIdx].m_numSamplePredRefLayers; i++)
-    {
-      xConfirmPara(m_acLayerCfg[layerIdx].m_samplePredRefLayerIds[i] > m_acLayerCfg[layerIdx].m_layerId, "Cannot reference higher layers");
-      xConfirmPara(m_acLayerCfg[layerIdx].m_samplePredRefLayerIds[i] == m_acLayerCfg[layerIdx].m_layerId, "Cannot reference the current layer itself");
-    }
-  }
-  xConfirmPara( (m_acLayerCfg[0].m_numMotionPredRefLayers != 0) && (m_acLayerCfg[0].m_numMotionPredRefLayers != -1), "Layer 0 cannot have any reference layers" );
+    xConfirmPara(m_apcLayerCfg[layerIdx]->m_numSamplePredRefLayers > layerIdx, "Cannot reference more layers than before current layer");
+    for(Int i = 0; i < m_apcLayerCfg[layerIdx]->m_numSamplePredRefLayers; i++)
+    {
+      xConfirmPara(m_apcLayerCfg[layerIdx]->m_samplePredRefLayerIds[i] > m_apcLayerCfg[layerIdx]->m_layerId, "Cannot reference higher layers");
+      xConfirmPara(m_apcLayerCfg[layerIdx]->m_samplePredRefLayerIds[i] == m_apcLayerCfg[layerIdx]->m_layerId, "Cannot reference the current layer itself");
+    }
+  }
+  xConfirmPara( (m_apcLayerCfg[0]->m_numMotionPredRefLayers != 0) && (m_apcLayerCfg[0]->m_numMotionPredRefLayers != -1), "Layer 0 cannot have any reference layers" );
   // NOTE: m_numMotionPredRefLayers  (for any layer) could be -1 (not signalled in cfg), in which case only the "previous layer" would be taken for reference
   if( layerIdx > 0 )
   {
-    xConfirmPara(m_acLayerCfg[layerIdx].m_numMotionPredRefLayers > layerIdx, "Cannot reference more layers than before current layer");
-    for(Int i = 0; i < m_acLayerCfg[layerIdx].m_numMotionPredRefLayers; i++)
-    {
-      xConfirmPara(m_acLayerCfg[layerIdx].m_motionPredRefLayerIds[i] > m_acLayerCfg[layerIdx].m_layerId, "Cannot reference higher layers");
-      xConfirmPara(m_acLayerCfg[layerIdx].m_motionPredRefLayerIds[i] == m_acLayerCfg[layerIdx].m_layerId, "Cannot reference the current layer itself");
-    }
-  }
-
-  xConfirmPara( (m_acLayerCfg[0].m_numActiveRefLayers != 0) && (m_acLayerCfg[0].m_numActiveRefLayers != -1), "Layer 0 cannot have any active reference layers" );
+    xConfirmPara(m_apcLayerCfg[layerIdx]->m_numMotionPredRefLayers > layerIdx, "Cannot reference more layers than before current layer");
+    for(Int i = 0; i < m_apcLayerCfg[layerIdx]->m_numMotionPredRefLayers; i++)
+    {
+      xConfirmPara(m_apcLayerCfg[layerIdx]->m_motionPredRefLayerIds[i] > m_apcLayerCfg[layerIdx]->m_layerId, "Cannot reference higher layers");
+      xConfirmPara(m_apcLayerCfg[layerIdx]->m_motionPredRefLayerIds[i] == m_apcLayerCfg[layerIdx]->m_layerId, "Cannot reference the current layer itself");
+    }
+  }
+
+  xConfirmPara( (m_apcLayerCfg[0]->m_numActiveRefLayers != 0) && (m_apcLayerCfg[0]->m_numActiveRefLayers != -1), "Layer 0 cannot have any active reference layers" );
   // NOTE: m_numActiveRefLayers  (for any layer) could be -1 (not signalled in cfg), in which case only the "previous layer" would be taken for reference
   if( layerIdx > 0 )
@@ -4242,11 +4278,11 @@
       predEnabledFlag[refLayer] = false;
     }
-    for(Int i = 0; i < m_acLayerCfg[layerIdx].m_numSamplePredRefLayers; i++)
-    {
-      predEnabledFlag[m_acLayerCfg[layerIdx].m_samplePredRefLayerIds[i]] = true;
-    }
-    for(Int i = 0; i < m_acLayerCfg[layerIdx].m_numMotionPredRefLayers; i++)
-    {
-      predEnabledFlag[m_acLayerCfg[layerIdx].m_motionPredRefLayerIds[i]] = true;
+    for(Int i = 0; i < m_apcLayerCfg[layerIdx]->m_numSamplePredRefLayers; i++)
+    {
+      predEnabledFlag[m_apcLayerCfg[layerIdx]->m_samplePredRefLayerIds[i]] = true;
+    }
+    for(Int i = 0; i < m_apcLayerCfg[layerIdx]->m_numMotionPredRefLayers; i++)
+    {
+      predEnabledFlag[m_apcLayerCfg[layerIdx]->m_motionPredRefLayerIds[i]] = true;
     }
     Int numDirectRefLayers = 0;
@@ -4255,8 +4291,8 @@
       if (predEnabledFlag[refLayer] == true) numDirectRefLayers++;
     }
-    xConfirmPara(m_acLayerCfg[layerIdx].m_numActiveRefLayers > numDirectRefLayers, "Cannot reference more layers than NumDirectRefLayers");
-    for(Int i = 0; i < m_acLayerCfg[layerIdx].m_numActiveRefLayers; i++)
-    {
-      xConfirmPara(m_acLayerCfg[layerIdx].m_predLayerIds[i] >= numDirectRefLayers, "Cannot reference higher layers");
+    xConfirmPara(m_apcLayerCfg[layerIdx]->m_numActiveRefLayers > numDirectRefLayers, "Cannot reference more layers than NumDirectRefLayers");
+    for(Int i = 0; i < m_apcLayerCfg[layerIdx]->m_numActiveRefLayers; i++)
+    {
+      xConfirmPara(m_apcLayerCfg[layerIdx]->m_predLayerIds[i] >= numDirectRefLayers, "Cannot reference higher layers");
     }
   }
@@ -4265,5 +4301,5 @@
   {
     xConfirmPara(m_numLayers != 2, "Adaptive resolution change works with 2 layers only");
-    xConfirmPara(m_acLayerCfg[1].m_iIntraPeriod == 0 || (m_adaptiveResolutionChange % m_acLayerCfg[1].m_iIntraPeriod) != 0, "Adaptive resolution change must happen at enhancement layer RAP picture");
+    xConfirmPara(m_apcLayerCfg[1]->m_iIntraPeriod == 0 || (m_adaptiveResolutionChange % m_apcLayerCfg[1]->m_iIntraPeriod) != 0, "Adaptive resolution change must happen at enhancement layer RAP picture");
   }
 
@@ -4280,10 +4316,10 @@
   if( layerIdx < MAX_LAYERS-1 )
   {
-    xConfirmPara(m_acLayerCfg[layerIdx].m_maxTidIlRefPicsPlus1 < 0 || m_acLayerCfg[layerIdx].m_maxTidIlRefPicsPlus1 > 7, "MaxTidIlRefPicsPlus1 must be in range 0 to 7");
+    xConfirmPara(m_apcLayerCfg[layerIdx]->m_maxTidIlRefPicsPlus1 < 0 || m_apcLayerCfg[layerIdx]->m_maxTidIlRefPicsPlus1 > 7, "MaxTidIlRefPicsPlus1 must be in range 0 to 7");
   }
 #if AUXILIARY_PICTURES
   if( layerIdx < MAX_LAYERS-1 )
   {
-    xConfirmPara(m_acLayerCfg[layerIdx].m_auxId < 0 || m_acLayerCfg[layerIdx].m_auxId > 2, "AuxId must be in range 0 to 2");
+    xConfirmPara(m_apcLayerCfg[layerIdx]->m_auxId < 0 || m_apcLayerCfg[layerIdx]->m_auxId > 2, "AuxId must be in range 0 to 2");
   }
 #endif 
@@ -4341,5 +4377,5 @@
   {
     printf("=== Layer %d settings === \n", layer);
-    m_acLayerCfg[layer].xPrintParameter();
+    m_apcLayerCfg[layer]->xPrintParameter();
     printf("\n");
   }
@@ -4704,5 +4740,5 @@
 {
   Int *tempArray = NULL;
-  numEntries = MAX_LAYERS;
+  numEntries = m_numLayers;
   // For all layer sets
   cfgStringToArrayNumEntries(&tempArray, cfgString, numEntries, logString);
